
class Node[T](val el: T, var next: Node[T])

class LinkedList[T] {
  private var front: Node[T] = null
  override def toString: String = {
    val s = new StringBuilder
    s ++= "["
    var p = front
    while (p != null) {
      s ++= p.el.toString
      if (p.next != null)
        s ++= ","
      p = p.next  
    }
    s ++= "]"
    s.toString
  }
  def first: Node[T] = {
    if (front == null)
      throw new NoSuchElementException
    else
      front
  }
  def prepend(el: T) {
    front = new Node(el, front)
  }
  def removeFirst() {
    if (front == null)
      throw new NoSuchElementException
    front = front.next
  }
  def addAfter(node: Node[T], el: T) {
    node.next = new Node(el, node.next)
  }
  def removeAfter(node: Node[T]) {
    if (node.next == null)
      throw new NoSuchElementException
    node.next = node.next.next
  }
  def before(node: Node[T]): Node[T] = {
    var p = front
    while (p.next != node)
      p = p.next
    p
  }
  def last: Node[T] = {
    var p = front
    while (p.next != null)
      p = p.next
    p
  }
  def append(el: T) {
    if (front == null)
      prepend(el)
    else
      addAfter(last, el)
  }
  def length: Int = {
    var count = 0
    var p = front
    while (p != null) {
      count += 1
      p = p.next
    }
    count
  }
  def apply(index: Int): T = {
    var p = front
    for (i <- 1 to index)
      p = p.next
    p.el
  }
}

val L = new LinkedList[String]
println(L)

L.prepend("Hello")
println(L)
L.prepend("World")
println(L)
L.addAfter(L.first, "CS206")
println(L)
var p = L.first
p = p.next.next
L.addAfter(p, "Here")
println(L)
println("Looking at " + p.el)
var q = L.before(p)
println("Element before is " + q.el)
println("Last element is " + L.last.el)
L.append("Funny")
L.append("Class")
println(L)
println("Last element is " + L.last.el)
val l = L.length
println("Length is " + l)
for (i <- 0 until l)
  printf("Element %d is %s\n", i, L(i))

